# Screenshot Options

With BrowserAPI, you can customise the screenshot by adding `screenshot_options` to your request. The value of this parameter should be a [stringified object](#what-is-a-stringified-object) and the currently supported keys for this object are:

* [**full\_page**](#1-full-page-screenshot)**: int** - accepted values are `1` ( ON ) and `0` ( OFF )
* [**screenshot\_selector**](#2-screenshot-specific-css-selector)**: string** - screenshot a particular CSS selector
* [**width & height**](#3-custom-viewport-size)**:** **int** - set Viewport size before taking the screenshot
* [**return\_html**](#4-return-html): **int** - accepted values are `1` ( ON ) and `0` ( OFF )

### Screenshot Options Integration Examples

#### #1: Full Page Screenshot

The full **GET** request for the `full_page` screenshot should be:

{% code overflow="wrap" %}

```
https://api.webscrapingapi.com/v1?api_key=<YOUR_API_KEY>&url=https://httpbin.org/&screenshot=1&screenshot_options==%7B%22full_page%22%3A%221%22%7D%0A"
```

{% endcode %}

{% tabs %}
{% tab title="cURL" %}
{% code overflow="wrap" %}

```bash
curl "https://api.webscrapingapi.com/v1\?api_key\=<YOUR_API_KEY>\&url\=https://httpbin.org\&render_js\=1\&screenshot\=1\&screenshot_options\=%7B%22full_page%22%3A%221%22%7D%0A"
```

{% endcode %}
{% endtab %}

{% tab title="NodeJS" %}
{% code overflow="wrap" %}

```javascript
const http = require("https");

const options = {
  "method": "GET",
  "hostname": "api.webscrapingapi.com",
  "port": null,
  "path": "/v1?api_key=<YOUR_API_KEY>&url=https%3A%2F%2Fhttpbin.org%2F&screenshot=1&screenshot_options==%7B%22full_page%22%3A%221%22%7D%0A"",
  "headers": {}
};

const req = http.request(options, function (res) {
  const chunks = [];

  res.on("data", function (chunk) {
    chunks.push(chunk);
  });

  res.on("end", function () {
    const body = Buffer.concat(chunks);
    console.log(body.toString());
  });
});

req.end();
```

{% endcode %}
{% endtab %}

{% tab title="Python" %}
{% code overflow="wrap" %}

```python
import requests

API_KEY = '<YOUR_API_KEY>'
SCRAPER_URL = 'https://api.webscrapingapi.com/v1'

TARGET_URL = 'https://httpbin.org/'

PARAMS = {
    "api_key":API_KEY,
    "url": TARGET_URL,
    "screenshot":1,
    "render_js":1,
    "screenshot_options":'{"full_page":"1"}'
}

response = requests.get(SCRAPER_URL, params=PARAMS)

print(response.text)
```

{% endcode %}
{% endtab %}

{% tab title="PHP" %}
{% code overflow="wrap" %}

```php
<?php

$api_key = '<YOUR_API_KEY>';
$url = 'https://www.webscrapingapi.com';

$payload = array(
    'url' => $url,
    'api_key' => $api_key,
    'render_js' => 1,
    'screenshot' => 1,
    'screenshot_options' => json_encode(array(
        'full_page' => '1',
    ))
);

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.webscrapingapi.com/v1?" . http_build_query($payload),
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "GET",
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  $json = json_decode($response, true);
  file_put_contents('myfile.png',base64_decode($json['screenshot']));
}

?>
```

{% endcode %}
{% endtab %}

{% tab title="Go" %}
{% code overflow="wrap" %}

```go
package main

import (
	"fmt"
	"net/http"
	"io/ioutil"
)

func main() {

	url := "https://api.webscrapingapi.com/v1?api_key=<YOUR_API_KEY>&url=https%3A%2F%2Fhttpbin.org%2F&screenshot=1&screenshot_options==%7B%22full_page%22%3A%221%22%7D%0A""

	req, _ := http.NewRequest("GET", url, nil)

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := ioutil.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

{% endcode %}
{% endtab %}

{% tab title="Java" %}
{% code overflow="wrap" %}

```java
HttpResponse<String> response = Unirest.get("https://api.webscrapingapi.com/v1?api_key=<YOUR_API_KEY>&url=https%3A%2F%2Fhttpbin.org%2F&screenshot=1&screenshot_options==%7B%22full_page%22%3A%221%22%7D%0A"")
  .asString();
```

{% endcode %}
{% endtab %}

{% tab title=".NET" %}
{% code overflow="wrap" %}

```csharp
var client = new RestClient("https://api.webscrapingapi.com/v1?api_key=<YOUR_API_KEY>&url=https%3A%2F%2Fhttpbin.org%2F&screenshot=1&screenshot_options==%7B%22full_page%22%3A%221%22%7D%0A"");
var request = new RestRequest(Method.GET);
IRestResponse response = client.Execute(request);
```

{% endcode %}
{% endtab %}

{% tab title="Ruby" %}
{% code overflow="wrap" %}

```ruby
require 'uri'
require 'net/http'
require 'openssl'

url = URI("https://api.webscrapingapi.com/v1?api_key=<YOUR_API_KEY>&url=https%3A%2F%2Fhttpbin.org%2F&screenshot=1&screenshot_options==%7B%22full_page%22%3A%221%22%7D%0A"")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
http.verify_mode = OpenSSL::SSL::VERIFY_NONE

request = Net::HTTP::Get.new(url)

response = http.request(request)
puts response.read_body
```

{% endcode %}
{% endtab %}
{% endtabs %}

{% hint style="danger" %} <mark style="color:red;">**Important!**</mark> The `url` parameter has to be encoded.

*( i.e. **\&url=https%3A%2F%2Fwww\.webscrapingapi.com%2F** )*
{% endhint %}

<details>

<summary>Response Example</summary>

```javascript
{
    "screenshot": "/9j/4AAQSkZJRgABAQAAAQABAAD/4gIoSUNDX1BST0ZJTEUAAQEAAAIYAAAAAAQwAABtbnRyUkdCIFhZWiAAAAAAAAAAAAAAAABhY3NwAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAQAA9tYAAQAAAADTLQAAAA...
}
```

</details>

#### #2: Screenshot Specific CSS Selector

The full **GET** request for the `screenshot_selector` screenshot should be:

{% code overflow="wrap" %}

```
https://api.webscrapingapi.com/v1?api_key=<YOUR_API_KEY>&url=https://httpbin.org/&screenshot=1&screenshot_options={"screenshot_selector":"$selector"}
```

{% endcode %}

{% tabs %}
{% tab title="cURL" %}
{% code overflow="wrap" %}

```bash
curl https://api.webscrapingapi.com/v1?api_key=<YOUR_API_KEY>&url=https://httpbin.org/&screenshot=1&screenshot_options='\{"screenshot_selector":".logo"\}'
```

{% endcode %}
{% endtab %}

{% tab title="NodeJS" %}
{% code overflow="wrap" %}

```javascript
const http = require("https");

const options = {
  "method": "GET",
  "hostname": "api.webscrapingapi.com",
  "port": null,
  "path": "/v1?api_key=<YOUR_API_KEY>&url=https%3A%2F%2Fhttpbin.org%2F&screenshot=1&screenshot_options={'screenshot_selector':'.logo'}",
  "headers": {}
};

const req = http.request(options, function (res) {
  const chunks = [];

  res.on("data", function (chunk) {
    chunks.push(chunk);
  });

  res.on("end", function () {
    const body = Buffer.concat(chunks);
    console.log(body.toString());
  });
});

req.end();
```

{% endcode %}
{% endtab %}

{% tab title="Python" %}
{% code overflow="wrap" %}

```python
import requests

API_KEY = '<YOUR_API_KEY>'
SCRAPER_URL = 'https://api.webscrapingapi.com/v1'

TARGET_URL = 'https://httpbin.org/'

PARAMS = {
    "api_key":API_KEY,
    "url": TARGET_URL,
    "screenshot":1,
    "render_js":1,
    "screenshot_options":'{"screenshot_selector":".logo"}'
}

response = requests.get(SCRAPER_URL, params=PARAMS)

print(response.text)
```

{% endcode %}
{% endtab %}

{% tab title="php" %}
{% code overflow="wrap" %}

```php


```

{% endcode %}
{% endtab %}
{% endtabs %}

<details>

<summary>Response Example</summary>

```javascript
{
    "screenshot": "/9j/4AAQSkZJRgABAQAAAQABAAD/4gIoSUNDX1BST0ZJTEUAAQEAAAIYAAAAAAQwAABtbnRyUkdCIFhZWiAAAAAAAAAAAAAAAABhY3NwAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAQAA9tYAAQAAAADTLQAAAA...
}
```

</details>

#### #3: Custom Viewport Size

The full **GET** request with custom `width` and `height` screenshot should be:

{% code overflow="wrap" %}

```
https://api.webscrapingapi.com/v1?api_key=<YOUR_API_KEY>&url=https://httpbin.org/&screenshot=1&screenshot_options={"width":"$size","height":"$size"}
```

{% endcode %}

{% tabs %}
{% tab title="cURL" %}
{% code overflow="wrap" %}

```bash
curl https://api.webscrapingapi.com/v1?api_key=<YOUR_API_KEY>&url=https://httpbin.org/&screenshot=1&screenshot_options='\{"width":"$size","height":"$size"\}'
```

{% endcode %}
{% endtab %}

{% tab title="NodeJS" %}
{% code overflow="wrap" %}

```javascript
const http = require("https");

const options = {
  "method": "GET",
  "hostname": "api.webscrapingapi.com",
  "port": null,
  "path": "/v1?api_key=<YOUR_API_KEY>&url=https%3A%2F%2Fhttpbin.org%2Fget&screenshot=1&screenshot_options=%7B%22width%22%3A%221000%22%2C%22height%22%3A%22500%22%7D",
  "headers": {}
};

const req = http.request(options, function (res) {
  const chunks = [];

  res.on("data", function (chunk) {
    chunks.push(chunk);
  });

  res.on("end", function () {
    const body = Buffer.concat(chunks);
    console.log(body.toString());
  });
});

req.end();
```

{% endcode %}
{% endtab %}

{% tab title="Python" %}

<pre class="language-python" data-overflow="wrap"><code class="lang-python">import requests

API_KEY = '&#x3C;YOUR_API_KEY>'
SCRAPER_URL = 'https://api.webscrapingapi.com/v1'

TARGET_URL = 'https://httpbin.org/'

PARAMS = {
    "api_key":API_KEY,
    "url": TARGET_URL,
    "screenshot":1,
    "render_js":1,
    "screenshot_options":'{"width":"1000","height":"500"}'
}

response = requests.get(SCRAPER_URL, params=PARAMS)

<strong>print(response.text)
</strong></code></pre>

{% endtab %}

{% tab title="php" %}
{% code overflow="wrap" %}

```php


```

{% endcode %}
{% endtab %}
{% endtabs %}

<details>

<summary>Response Example</summary>

```javascript
{
    "screenshot": "/9j/4AAQSkZJRgABAQAAAQABAAD/4gIoSUNDX1BST0ZJTEUAAQEAAAIYAAAAAAQwAABtbnRyUkdCIFhZWiAAAAAAAAAAAAAAAABhY3NwAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAQAA9tYAAQAAAADTLQAAAA...
}
```

</details>

#### #4: Return HTML

The full **GET** request that will `return_html` should be:

{% code overflow="wrap" %}

```
https://api.webscrapingapi.com/v1?api_key=<YOUR_API_KEY>&url=https://httpbin.org/&screenshot=1&screenshot_options={"return_html":"1"}
```

{% endcode %}

{% tabs %}
{% tab title="cURL" %}
{% code overflow="wrap" %}

```bash
curl https://api.webscrapingapi.com/v1?api_key=<YOUR_API_KEY>&url=https://httpbin.org/&screenshot=1&screenshot_options='\{"return_html":"1"\}'
```

{% endcode %}
{% endtab %}

{% tab title="NodeJS" %}
{% code overflow="wrap" %}

```javascript
const http = require("https");

const options = {
  "method": "GET",
  "hostname": "api.webscrapingapi.com",
  "port": null,
  "path": "/v1?api_key=<YOUR_API_KEY>&url=https%3A%2F%2Fhttpbin.org%2Fget&screenshot=1&screenshot_options=%7B%22return_html%22%3A%221%22%7D",
  "headers": {}
};

const req = http.request(options, function (res) {
  const chunks = [];

  res.on("data", function (chunk) {
    chunks.push(chunk);
  });

  res.on("end", function () {
    const body = Buffer.concat(chunks);
    console.log(body.toString());
  });
});

req.end();
```

{% endcode %}
{% endtab %}

{% tab title="Python" %}
{% code overflow="wrap" %}

```python
import requests

API_KEY = '<YOUR_API_KEY>'
SCRAPER_URL = 'https://api.webscrapingapi.com/v1'

TARGET_URL = 'https://httpbin.org/'

PARAMS = {
    "api_key":API_KEY,
    "url": TARGET_URL,
    "screenshot":1,
    "render_js":1,
    "screenshot_options":'{"return_html":"1"}'
}

response = requests.get(SCRAPER_URL, params=PARAMS)

print(response.text)
```

{% endcode %}
{% endtab %}

{% tab title="php" %}
{% code overflow="wrap" %}

```php


```

{% endcode %}
{% endtab %}
{% endtabs %}

<details>

<summary>Response Example</summary>

```javascript
{
    "screenshot": "/9j/4AAQSkZJRgABAQAAAQABAAD/4gIoSUNDX1BST0ZJTEUAAQEAAAIYAAAAAAQwAABtbnRyUkdCIFhZWiAAAAAAAAAAAAAAAABhY3NwAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAQAA9tYAAQAAAADTLQAAAA...
}
```

</details>

### What is a stringified object?

We define a stringified object as an object wrapped between quotation marks. For example, in this Python code, the stringified object is available on line `13`:

{% code lineNumbers="true" %}

```python
import requests

API_KEY = '<YOUR_API_KEY>'
SCRAPER_URL = 'https://api.webscrapingapi.com/v1'

TARGET_URL = 'https://www.webscrapingapi.com/'

PARAMS = {
    "api_key":API_KEY,
    "url": TARGET_URL,
    "render_js":1,
    "screenshot":1,
    "screenshot_options":'{"<KEY>":"<VALUE>"}'
}

response = requests.get(SCRAPER_URL, params=PARAMS)
print(response.text) 
```

{% endcode %}

{% hint style="warning" %}
If you are using cURL to make your request, make sure to escape the curly brackets in order for your request to pass: `&screenshot_options='\{"full_page":"1"\}'.`
{% endhint %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.webscrapingapi.com/browser-api/advanced-api-features/screenshot-options.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
